webapp/org_public_profile/urls.py
from django.conf.urls import patterns, url

urlpatterns = patterns(
    'org_public_profile.views',
    url(r'^our/profile/edit/$', 'own_profile', name='org_profile_edit'),
    url(r'^our/profile/edit/public/$', 'own_profile_sharing', name='org_profile_sharing'),
    url(r'^network/(?P<target_slug>.+)/$', 'other_profile', name='org_other_profile'),
)

webapp/rbac/urls.py
from django.conf.urls import patterns, url

from .views import rbac_control_panel


urlpatterns = patterns(
    '',
    url(r'^control-panel/$', rbac_control_panel, name='rbac_control_panel'),
)

webapp/org_public_profile/models.py
from django.db import models
from django.utils.translation import ugettext_lazy as _

from organization.models import Organization, upload_to_org


class OrganizationPublicProfile(models.Model):

    organization = models.OneToOneField(Organization, related_name='public_profile')
    # comma separated list of section IDs to display, not including business_card
    SECTIONS_CHOICES = (
        ('business_card', _("Organization business card")),
        ('certifications', _("Certification list")),
        ('map', _("Location on map")),
        ('photos', _("Photos")),
        ('products', _("Product list"))
    )
    visible_sections = models.CharField(max_length=1000, default='business_card', blank=True)
    settings_json = models.TextField(blank=False, default='{}')
    is_public = models.BooleanField(default=True)
    profile_photo = models.ImageField(
        verbose_name=_(u'Profile photo'),
        upload_to=upload_to_org,
        blank=True, null=True)

    class Meta:
        db_table = 'OrganizationPublicProfile'
        permissions = (
            ('view_organizationpublicprofile', 'Can view organization public profile'),
        )

    def __unicode__(self):
        return u"[{}] public profile settings".format(self.organization.name)

    @property
    def visible_sections_list(self):
        return self.visible_sections.split(',')


class ProfilePhoto(models.Model):
    """
    Photo used in photo gallery on the organization public profile.
    """
    photo = models.ImageField(
        verbose_name=_(u'Photo'),
        upload_to=upload_to_org,
        blank=True, null=True)
    profile = models.ForeignKey('OrganizationPublicProfile', related_name='photos')

    class Meta:
        db_table = 'ProfilePhoto'
        permissions = (
            ('view_profilephoto', 'Can view profile photo'),
        )

    def __unicode__(self):
        return u"%s" % (self.id)

    @property
    def organization(self):
        return self.profile.organization

webapp/org_public_profile/forms.py
from django import forms
from django.utils.translation import ugettext_lazy as _
from org_public_profile.models import OrganizationPublicProfile


class ProfileFieldsForm(forms.Form):
    """
    Profile settings form.
    """
    business_card = forms.BooleanField(
        label=_("Business card"),
        required=False,
        initial=True,
    )
    photos = forms.BooleanField(
        label=_("Photos"),
        required=False,
        initial=True,
        widget=forms.CheckboxInput(attrs={
            "ng-model": "visibleSections.photos"
        })
    )
    certifications = forms.BooleanField(
        label=_("Certifications"),
        required=False,
        widget=forms.CheckboxInput(attrs={
            "ng-model": "visibleSections.certifications"
        })
    )
    products = forms.BooleanField(
        label=_("Products"),
        required=False,
        widget=forms.CheckboxInput(attrs={
            "ng-model": "visibleSections.products"
        })
    )
    map = forms.BooleanField(
        label=_("Location on map"),
        required=False,
        widget=forms.CheckboxInput(attrs={
            "ng-model": "visibleSections.map"
        })
    )

    def __init__(self, *args, **kwargs):
        # OrganizationPublicProfile instance
        try:
            self.instance = kwargs.pop('instance')
            self.initial = {}
            for visible_section in self.instance.visible_sections:
                self.initial[visible_section] = True
        except KeyError:
            pass
        super(ProfileFieldsForm, self).__init__(*args, **kwargs)

    def save(self):
        if self.instance:
            visible_sections_list = []
            section_names = [i[0] for i in OrganizationPublicProfile.SECTIONS_CHOICES]
            for key, value in self.cleaned_data.items():
                if key == 'business_card':
                    value = True
                if key in section_names and value:
                    visible_sections_list.append(key)
            self.instance.visible_sections = ','.join(visible_sections_list)
            self.instance.save()

webapp/org_public_profile/views.py
import json
import logging

from organization.models import CertificationType

logger = logging.getLogger(__name__)

from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.shortcuts import render, redirect, get_object_or_404
from django.utils.translation import ugettext as _

from organization.views_organization import get_organization_context
from sams.constants import ICONS
from sams.decorators import session_organization_required

from .forms import ProfileFieldsForm
from .models import *


@login_required
@session_organization_required
def own_profile(request, *args, **kwargs):
    context, organization = get_organization_context(request, kwargs, 'own_profile')
    profile, created = OrganizationPublicProfile.objects.get_or_create(organization=organization)
    context['target_organization'] = organization
    context.update({
        "page_title": context['organization'].name,
        "page_title_secondary": _("organization"),
        'is_editable': True,
        'all_sections': OrganizationPublicProfile.SECTIONS_CHOICES,
        'visible_sections': profile.visible_sections,
        'profile': profile,
        # 'body_class': 'gray'
        'certificate_types': CertificationType.objects.exclude(code='').distinct().values_list('code', flat=True)
    })
    context['breadcrumbs'] += [
        {
            'text': _("Public profile"),
            'icon': ICONS['organization_profile']
        }
    ]

    section_names = [i[0] for i in OrganizationPublicProfile.SECTIONS_CHOICES]

    if request.method == 'POST':
        # POST
        form = ProfileFieldsForm(request.POST, instance=profile)
        if form.is_valid():
            form.save()
            messages.success(request, _("Saved."))
    else:
        # GET, etc.
        form = ProfileFieldsForm(instance=profile)
    visible_sections = profile.visible_sections.strip().split(',')
    visible_sections_dict = {
        section: section in visible_sections
        for section in section_names
    }
    visible_sections_json = json.dumps(visible_sections_dict)
    context.update({
        'form': form,
        'visible_sections': visible_sections,
        'visible_sections_data': visible_sections_json
    })
    return render(request, 'org_public_profile/own_profile.html', context)


@login_required
@session_organization_required
def own_profile_sharing(request, *args, **kwargs):
    """
    Turns public profile of organization is_public on/off based on form `public` variable
    """
    context,organization = get_organization_context(request, kwargs, 'profile_sharing')
    try:
        public_profile = organization.public_profile
    except OrganizationPublicProfile.DoesNotExist:
        public_profile = OrganizationPublicProfile(
            organization=organization
        )
    if request.method == 'POST':
        if request.POST.get('public') == 'true':
            is_public = True
        elif request.POST.get('public') == 'false':
            is_public = False
        else:
            raise Exception("Bad is_public value")
        organization.public_profile.is_public = is_public
        organization.public_profile.save()
        return redirect('org_profile_edit', organization_slug=organization.slug)
    else:
        raise Exception("POST only!")


@login_required
@session_organization_required
def other_profile(request, *args, **kwargs):
    """
    Public profile
    """
    context,organization = get_organization_context(request, kwargs, 'other_profile')
    target_slug = kwargs['target_slug']
    target_organization = get_object_or_404(Organization, slug=target_slug)
    profile,created = OrganizationPublicProfile.objects.get_or_create(organization=target_organization)
    context['profile'] = profile
    context["target_organization"] = target_organization
    context.update({
        'page_title': target_organization.name,
        'page_title_secondary': _('organization'),
        # 'body_class': 'gray'
    })
    return render(request, 'org_public_profile/profile.html', context)

webapp/org_public_profile/templates/org_public_profile/_org_public_profile.html
{% comment %}

Organization public profile

Separated into part so it can be included in multiple layouts (internal vs external)

Context:
    organization: Organization to display
    is_editable: Show editors or not (shortcut for whether this is my org or not)

{% endcomment %}
{% load i18n %}
{% load sekizai_tags %}

{% addtoblock "javascript-before-bundle" %}
    <script src="{{ STATIC_URL }}frontend/leaflet/leaflet.js"></script>
{% endaddtoblock %}

{% addtoblock "css" %}
    <link rel="stylesheet" href="{{ STATIC_URL }}frontend/leaflet/leaflet.css" />
{% endaddtoblock %}

{% addtoblock 'javascript' %}
    <script src="{{ STATIC_URL }}bower-components/fancybox/source/jquery.fancybox.js"></script>
{% endaddtoblock %}

{% addtoblock "javascript-before-bundle" %}
    <script src="{{ STATIC_URL }}frontend/angular-leaflet-directive.js"></script>
{% endaddtoblock %}

{% addtoblock "javascript" %}
    <script>
        $('.lightbox').fancybox()
    </script>
{% endaddtoblock %}

{% addtoblock "javascript" %}
    <script>
        var lat = {{ profile.organization.map_latitude|stringformat:"f" }}
        var long = {{  profile.organization.map_longitude|stringformat:"f" }}
        var zoom = {{  profile.organization.map_zoom }}
        var map = L.map('map').setView([lat, long], zoom)

        L.tileLayer('http://{s}.tile.osm.org/{z}/{x}/{y}.png', {
            attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
        }).addTo(map)

        // add a marker in the given location, attach some popup content to it and open the popup
        L.marker([lat, long]).addTo(map)
{#                .bindPopup('{{ profile.organization.name }}')#}
{#                .openPopup();#}

        L.attributionControl = false
    </script>
{% endaddtoblock %}



<div class="organization-public-profile" >


    {% addtoblock 'css' %}
        <link rel="stylesheet" href="{{ STATIC_URL }}bower-components/fancybox/source/jquery.fancybox.css" />
    {% endaddtoblock %}

    {% if profile.profile_photo %}
    <div class="public-profile-header">
        <img class="public-profile-header-img" src="{{ MEDIA_URL }}{{ profile.profile_photo }}" />
    </div>
    {% endif %}


    {# Organization header #}
    <div class="profile-section">
        <div class="profile-section-content">

            <div class="box-header-toolbar">
                {% if is_editable %}
                    <a
                        href="{% url 'my_org_detail' organization.slug %}#business_card/edit"
                        class="btn btn-default btn-sm"
                        rel="tooltip" title="{% trans "Edit" %}"
                    >
                        <span class="{{ ICONS.edit }}"></span>
                    </a>
                {% endif %}
            </div>

            {% include "org_public_profile/_organization_business_card.html" %}

        </div>
    </div>

    {# Photos, #}
    {% if true or is_editable or 'photos' in profile.visible_sections_list %}
        {% include 'org_public_profile/sections/_section_photos.html' %}
    {% endif %}

    {# Certifications #}
    {% if true or is_editable or 'certifications' in profile.visible_sections_list %}
        {% include 'org_public_profile/sections/_section_certificates.html' %}
    {% endif %}

    {# Products #}
    {% if true or is_editable or 'products' in profile.visible_sections_list %}
        {% include 'org_public_profile/sections/_section_products.html' %}
    {% endif %}

    {# Map #}
    {% if is_editable or 'map' in visible_sections_list %}
        {% include 'org_public_profile/sections/_section_map.html' %}
    {% endif %}



</div>


{% addtoblock "javascript" %}
    {% if is_editable %}
{#        <script language="javascript" src="{{ STATIC_URL }}lib/knockout.js"></script>#}
{#        <script language="javascript" src="{{ STATIC_URL }}lib/knockout.mapping-latest.js"></script>#}
{#        <script language="javascript" src="{{ STATIC_URL }}org_public_profile/org_public_profile.js"></script>#}
    {% endif %}
{% endaddtoblock %}

webapp/org_public_profile/templates/org_public_profile/_organization_business_card.html
{% load i18n %}

{% comment %}

Organization business card

Context:
    organization

{% endcomment %}

<div class="organization-business-card">

            <div class="box-header-toolbar">
                {% if is_editable %}
                    <a href="{% url 'my_org_form_full' membership.pk %}"
                       class="btn btn-default btn-sm"
                       rel="tooltip" title="{% trans "Edit" %}"
                    >
                        <span class="{{ ICONS.edit }}"></span>
                        {% trans "Edit" %}
                    </a>
                {% endif %}
                <div class="clearfix"></div>
            </div>

        <div class="logo-column">
            {% if organization.logo %}
                <img src="{{ MEDIA_URL }}{{ organization.logo }}" alt="" class="logo"/>
            {% else %}
                <span class="{{ ICONS.organization }} organization-logo"></span>
            {% endif %}
        </div>
        <div class="content-column">
            <div class="name">{{ organization }}</div>
            <div class="description">{{ organization.description }}</div>

            <div class="contact">

                {% if organization.mailing_address_one_line %}
                    <div class="address">
                        <span class="{{ ICONS.address }}"></span>
                        {{ organization.mailing_address_one_line }}
                        <br />
                    </div>
                {% endif %}

                {% if organization.phone %}
                    <span class="{{ ICONS.phone }}"></span>
                    {{ organization.phone }}
                {% endif %}

                {% if organization.email %}
                    &nbsp;&nbsp;/&nbsp;
                    <span class="{{ ICONS.email }}"></span>
                    <a href="mailto:{{ organization.email }}">
                        {{ organization.email }}
                    </a>
                {% endif %}

                {% if organization.url %}
                    &nbsp;&nbsp;/&nbsp;
                    <span class="{{ ICONS.link }}"></span>
                    <a href="{{ organization.url }}" target="_blank">
                        {% trans "Visit website" %}
                    </a>
                {% endif %}
            </div>
        </div>
</div>

webapp/org_public_profile/templates/org_public_profile/own_profile.html
{% extends 'core/layout_org.html' %}
{% load bootstrap %}
{% load i18n %}
{% load sekizai_tags %}

{% block content %}
    <div class="row">

        <div class="col-md-2">
            {% include 'sams/_nav2_links.html' %}
            {% block sidebar_left %}
            {% endblock %}
        </div>

        <div class="col-md-7">
            <div class="page-section page-section-boxed">
                <div class="page-section-content">
                    <p class="">
                        {#                    <span class="{{ ICONS.organization_profile }} icon-2x icon-bordered pull-left"></span>#}
                        {% trans "This is your public profile." %}<br />
                        {% trans "It is visible to your partners on AgriPlace." %}
                    </p>
                </div>
            </div>

            <div class="page-section page-section-boxed">
                {% include 'org_public_profile/_org_public_profile.html' %}
            </div>
        </div>

        <div class="col-md-3">

            <div class="page-section page-section-boxed">
                <div class="page-section-header">
                    <h2>
                        {% trans "Profile options" %}
                    </h2>
                </div>
                <div class="page-section-content">

                    {# Profile options form #}

                    <form id="profile_fields_form" method="post" action="{{ request.path }}">
                        {% csrf_token %}

                        <div class="form-group">
                            <div class="checkbox">
                                <label>
                                    <input checked="checked" id="id_business_card" name="business_card" type="checkbox"/>
                                    <span>{% trans "Business card" %}</span>
                                </label>
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="checkbox">
                                <label>
                                    <input checked="checked" id="id_photos" name="photos" ng-model="visibleSections.photos" type="checkbox"/>
                                    <span>{% trans "Photos" %}</span>
                                </label>
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="checkbox">
                                <label>
                                    <input id="id_certifications" name="certifications" ng-model="visibleSections.certifications" type="checkbox"/>
                                    <span>{% trans "Certifications" %}</span>
                                </label>
                            </div>
                        </div>


                        <div class="form-group">
                            <div class="checkbox">
                                <label>
                                    <input id="id_products" name="products" ng-model="visibleSections.products" type="checkbox"/>
                                    <span>{% trans "Crops" %}</span>
                                </label>
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="checkbox">
                                <label>
                                    <input id="id_map" name="map" ng-model="visibleSections.map" type="checkbox"/>
                                    <span>{% trans "Location on map" %}</span>
                                </label>
                            </div>
                        </div>

                        <div>
                            <button type="submit" class="btn btn-primary" id="save_profile_options_btn">
                                {% trans "Save" %}
                            </button>
                        </div>
                    </form>

                </div>
            </div>

            {% comment %}
            <div class="page-section page-section-boxed">
                <div class="page-section-header">
                    <h2>
                        {% trans "Sharing" %}
                    </h2>
                </div>
                <div class="page-section-content">

                    {# Profile sharing form #}
                    <form action="{% url 'org_profile_sharing' organization.slug %}" method="post">
                        {% csrf_token %}
                        {% if organization.public_profile.is_public %}
                            <input type="hidden" name="public" value="false" />
                            <p>
                                {% trans "Your profile is now public at:" %}
                                <br/>
                                <a href="{{ organization.public_profile_url }}">
                                    {{ organization.public_profile_url }}
                                </a>
                            </p>
                            <button type="submit" class="btn btn-default">
                                {% trans "Make profile private" %}
                            </button>
                        {% else %}
                            <input type="hidden" name="public" value="true" />
                            <p>
                                {% trans "Your profile is now private." %}
                            </p>
                            <button type="submit" class="btn btn-primary">
                                <span class="icon-check"></span>
                                Make public
                            </button>
                        {% endif %}
                    </form>

                </div>
            </div>
            {% endcomment %}

        </div>
    </div>

{% endblock %}

webapp/org_public_profile/templates/org_public_profile/profile.html
{% extends "core/layout_app.html" %}

{% comment %}
    Organization public profile page

    Context variables:
        target_organization

{% endcomment %}


{% block content %}
    <div class="row">
        <div class="col-md-8 col-md-offset-2">
            {% include 'org_public_profile/_org_public_profile.html' with organization=target_organization %}
        </div>
        <div class="col-md-2">
            {% include 'partners/parts/_partner_actions.html' %}
        </div>
    </div>


{% endblock %}